package com.fp.persistence.pgeneral.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENECATALOGDETAILTEST*/
@Embeddable
public class TgeneCatalogDetailTestKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String catalog;

@Column(name="CATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String catalogcode;

/**Contructor por defecto*/
public TgeneCatalogDetailTestKey(){}
/**Contructor de TgeneCatalogDetailTestKey
@param pCatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pCatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
public TgeneCatalogDetailTestKey(String pCatalog,String pCatalogcode){
 catalog=pCatalog;
 catalogcode=pCatalogcode;
}
/**Obtiene el valor de catalog
@return valor de catalog*/
public String getCatalog(){
  return catalog;
}
/**Fija el valor de catalog
@param pCatalog nuevo Valor de catalog*/
public void setCatalog(String pCatalog){
  catalog=pCatalog;
}

/**Obtiene el valor de catalogcode
@return valor de catalogcode*/
public String getCatalogcode(){
  return catalogcode;
}
/**Fija el valor de catalogcode
@param pCatalogcode nuevo Valor de catalogcode*/
public void setCatalogcode(String pCatalogcode){
  catalogcode=pCatalogcode;
}

/**Implementacion de la comparacion de TgeneCatalogDetailTestKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneCatalogDetailTestKey))return false;
  TgeneCatalogDetailTestKey that = (TgeneCatalogDetailTestKey) o;
  if (this.getCatalog() == null || that.getCatalog() == null){
      return false;
  }
  if (! this.getCatalog().equals(that.getCatalog())){
    return false;
  }
  if (this.getCatalogcode() == null || that.getCatalogcode() == null){
      return false;
  }
  if (! this.getCatalogcode().equals(that.getCatalogcode())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TgeneCatalogDetailTestKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCatalog() == null ? 0 : this.getCatalog().hashCode());
    result = result * 37 + (this.getCatalogcode() == null ? 0 : this.getCatalogcode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
